/**
 * Задание 2.
 *
 * Написать функцию-фабрику квадратов createSquares.
 *
 * Функция обладает двумя параметром — количеством квадратов для создания и размер квадратов.
 *
 * Если пользователь ввёл количество квадратов для создания в недопустимом формате —
 * запрашивать данные повторно до тех пор, пока данные не будут введены корректно.
 *
 * Максимальное количество квадратов для создания — 10.
 * Если пользователь решил создать более 10-ти квадратов — сообщить ему о невозможности такой операции
 * и запрашивать данные о количестве квадратов для создания до тех пор, пока они не будут введены корректно.
 *
 * Размер каждого квадрата в пикселях нужно получить интерактивно посредством диалогового окна prompt.
 *
 * Если пользователь ввёл размер квадрата в недопустимом формате —
 * запрашивать данные повторно до тех пор, пока данные не будут введены корректно.
 *
 * Цвет каждого квадрата необходимо запросить после введения размера квадрата в корректном виде.
 *
 * Итого последовательность ввода данных о квадратах выглядит следующим образом:
 * - Размер квадрата n;
 * - Цвет квадрата n;
 * - Размер квадрата n + 1;
 * - Цвет квадрата n + 1.
 * - Размер квадрата n + 2;
 * - Цвет квадрата n + 3;
 * - и так далее...
 *
 * Если не любом этапе сбора данных о квадратах пользователь кликнул по кнопке «Отмена»,
 * необходимо остановить процесс создания квадратов и вывести в консоль сообщение:
 * «Операция прервана пользователем.».
 *
 * Все стили для каждого квадрата задать через JavaScript за раз.
 *
 * Тип элемента, описывающего каждый квадрат — div.
 * Задать ново-созданным элементам CSS-классы: .square-1, .square-2, .square-3 и так далее.
 *
 * Все квадраты необходимо сделать потомками body документа.
 */

// 1. Сделаем функцию которая будет запрашивать количество генерируемых кубиков
// 2. Сделаем сделаем проверку
// 3. Создадаим массив нужного нам размера.
// 4. Создадаим новый массив кубиков, нужного размера и цвета

const createSquares = () => {
	let quantity = Number.parseInt( prompt( "Enter the quantity of square - " ) )

	while ( !Number( quantity ) || quantity === null || quantity > 10 ) {
		quantity = Number.parseInt( prompt( "Enter the quantity of square again - " ) )
	}

	const array = new Array( quantity ).fill( null ).map( ( elem, index ) => {
		const newSquare = document.createElement( "div" );
		newSquare.classList.add( `square-${ index + 1 }` );
		const size = Number.parseInt( prompt( `Enter the size of square ${ index + 1 } - ` ) )
		const color = prompt( `Enter the color of square ${ index + 1 } - ` )
		newSquare.style.cssText = `
      width:${ size }px;
      height:${ size }px;
      background-color: ${ color };
      `;
		return newSquare;
	} )
	array.forEach( item => {
		document.body.appendChild( item );
	} )
}
createSquares();